org.eclipse.january.dataset

## Interface ILazyWriteableDataset

- All Superinterfaces:
    IDynamicDataset, IDynamicShape, ILazyDataset, IMetadataProvider, INameable, Serializable
  All Known Implementing Classes:
    LazyWriteableDataset

      public interface ILazyWriteableDataset
      extends IDynamicDataset

  This sub-interface adds the ability to write to a lazy dataset slice-by-slice

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `UNLIMITED` See `IDynamicDataset.UNLIMITED`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `int[]` | `getChunking()` Get chunking
    `Object` | `getFillValue()` Get the value used to fill an un-initialized dataset
    `void` | `setChunking(int... chunks)` Set chunking
    `void` | `setFillValue(Object fill)` Set the value used to fill an un-initialized dataset
    `void` | `setSaver(ILazySaver saver)` Set saver
    `void` | `setSlice(IMonitor monitor, IDataset data, int[] start, int[] stop, int[] step)` Set a slice of the dataset
    `void` | `setSlice(IMonitor monitor, IDataset data, SliceND slice)` Set a slice of the dataset
    `void` | `setSliceSync(IMonitor monitor, IDataset data, SliceND slice)` Set a slice of the dataset synchronously
    `void` | `setWritingAsync(boolean async)` Set writing slices as asynchronous
    `ILazyWriteableDataset` | `squeezeEnds()` Remove dimensions of 1 from ends of shape of the dataset

    - ### Methods inherited from interface org.eclipse.january.dataset.ILazyDataset

      `addMetadata, clearMetadata, clone, getElementClass, getElementsPerItem, getErrors, getRank, getShape, getSize, getSlice, getSlice, getSlice, getSlice, getSlice, getSlice, getSliceView, getSliceView, getSliceView, getTransposedView, hasErrors, setErrors, setMetadata, setShape`

    - ### Methods inherited from interface org.eclipse.january.dataset.IMetadataProvider

      `getFirstMetadata, getMetadata, getMetadata`

    - ### Methods inherited from interface org.eclipse.january.INameable

      `getName, setName`

    - ### Methods inherited from interface org.eclipse.january.dataset.IDynamicShape

      `addDataListener, fireDataListeners, getDataset, getMaxShape, refreshShape, removeDataListener, resize, setMaxShape, startUpdateChecker`

- - ### Field Detail

    - #### UNLIMITED

          static final int UNLIMITED

      See `IDynamicDataset.UNLIMITED`
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getChunking

          int[] getChunking()

      Get chunking
      Returns:
        chunks (can be null)

    - #### setChunking

          void setChunking(int... chunks)

      Set chunking
      Parameters:
        `chunks` - chunk shape

    - #### setSaver

          void setSaver(ILazySaver saver)

      Set saver
      Parameters:
        `saver` - lazy saver

    - #### setSlice

          void setSlice(IMonitor monitor,
                        IDataset data,
                        SliceND slice)
                 throws DatasetException

      Set a slice of the dataset
      Parameters:
        `monitor` - can be null
        `data` - input
        `slice` - an n-D slice
      Throws:
        `DatasetException` - when cannot write data

    - #### setSlice

          void setSlice(IMonitor monitor,
                        IDataset data,
                        int[] start,
                        int[] stop,
                        int[] step)
                 throws DatasetException

      Set a slice of the dataset
      Parameters:
        `monitor` - can be null
        `data` - input
        `start` - specifies the starting indexes (can be null for origin)
        `stop` - specifies the stopping indexes (can be null for end)
        `step` - specifies the steps in the slice (can be null for unit steps)
      Throws:
        `DatasetException` - when cannot write data

    - #### setSliceSync

          void setSliceSync(IMonitor monitor,
                            IDataset data,
                            SliceND slice)
                     throws DatasetException

      Set a slice of the dataset synchronously
      Parameters:
        `monitor` - can be null
        `data` - input
        `slice` - an n-D slice
      Throws:
        `DatasetException` - when cannot write data

    - #### setWritingAsync

          void setWritingAsync(boolean async)

      Set writing slices as asynchronous
      Parameters:
        `async` - true if writing should be asynchronous

    - #### getFillValue

          Object getFillValue()

      Get the value used to fill an un-initialized dataset
      Returns:
        fill value

    - #### setFillValue

          void setFillValue(Object fill)

      Set the value used to fill an un-initialized dataset
      Parameters:
        `fill` - value

    - #### squeezeEnds

          ILazyWriteableDataset squeezeEnds()

      Description copied from interface: `ILazyDataset`
      Remove dimensions of 1 from ends of shape of the dataset
      Specified by:
        `squeezeEnds` in interface `ILazyDataset`
      Returns:
        this

Copyright © 2014–2022 Eclipse Foundation. All rights reserved.